
{----------------------------------------------------------------------------------------------}
{                                                                                              }
{ Ce code est plus fait pour etre lu que pour etre execute. Il a ete cree dans le but de servir}
{ d'aide memoire plus tard. Il marche (sans plus), mais son but est uniquement demonstratif.   }
{                                                                                              }
{ Beaucoup de constantes deja declarees dans les headers Windows sont redeclarees ici, dans le }
{ seul but de faciliter la lecture de ce source.                                               }
{                                                                                              }
{ Vous pouvez librement utiliser, modifier ou diffuser ce code tant que vous restez dans une   }
{ logique de partage et de non-profit.                                                         }
{                                                                                              }
{ Pour toutes remarques --> phaz at dune2 point info                                           }
{                                                                                              }
{    ~ Phaz ~                                                                                  }
{                                                                                              }
{----------------------------------------------------------------------------------------------}




UNIT LookupAccount ;


INTERFACE
 Uses
   JwaWinNT;

 Const
   // Utile pour HeapAlloc.
   HEAP_ZERO_MEMORY     = JwaWinNT.HEAP_ZERO_MEMORY ; // (=$08) Deja declare dans JwaWinNT.pas

   // Ces constantes sont deja declarees dans JwaWinError.pas. Elles sont redefinies ici avec un
   // nom plus court et plus facile a retenir. (Ce n'est pas obligatoire)
   ACCESS_DENIED        = 5    ;            // pour ERROR_ACCESS_DENIED
   SERVER_NOT_FOUND     = 1722 ;            // pour RPC_S_SERVER_UNAVAILABLE
   ACCOUNT_NOT_FOUND    = 1332 ;            // pour ERROR_NONE_MAPPED


 Type
   PSID = JwaWinNT.PSID ;      // Pour que le programme qui utilise cette unite puisse se servir
                               // du type PSID sans utiliser JwaWinNT

 // Exemple d'appel de la fonction LookupAccountName :
 // Renvoie le SID d'une entite principale de securite a partir de son nom chaine.
 Function GetAccountSid (StrSystemName  : String  ;
                         StrAccountName : String  ;
                         Var StrDomain  : String  ;
                         Var caSidType  : Cardinal;
                         Var caError    : Cardinal)
                                        : PSID    ;

 // Exemple d'appel de la fonction LookupAccountSid :
 // Renvoie le nom chaine d'une entite principale de securite a partir de son SID
 Function GetAccountName (StrSystemName : String  ;
                          lpSid         : PSID    ;
                          Var StrDomain : String  ;
                          Var caSidType : Cardinal;
                          Var caError   : Cardinal)
                                        : String  ;

 // Exemple d'appel de la fonction ConvertStringSidToSid :
 // Convertit un SID chaine en SID binaire
 Function Str2Sid (StrSid : String)
                          : PSID  ;

 // Exemple d'appel de la fonction ConvertSidToStringSid :
 // Convertit un SID binaire en SID chaine
 Function Sid2Str (lpSid  : PSID  )
                          : String;

 // Fonction simple, pratiquement sans interet. Son seul merite est de montrer que l'on peut
 // reconnaitre les differentes entites principales de securite (Compte utilisateur, groupe,
 // domaine, alias, etc. ) a l'aide des constantes declares dans WinNT.h

 Function SidType2Str (caSidType : Cardinal)
                                 : String  ;

IMPLEMENTATION
 Uses
   JwaWinBase,
   JwaSddl,
   JwaWinType, 
   JwaWinError ;

(*
================================================================================================
::::::::::::::::::::::::::::::::::::  LookupAccountName   ::::::::::::::::::::::::::::::::::::::
================================================================================================


Description : (source : MSDN)

   LookupAccountName renvoie le SID d'un principal de securite (compte utilisateur, alias,
   groupe, etc.) et le nom du domaine sur lequel il a ete trouve.

   L'appelant doit fournir deux arguments :
    - le nom du principal de securite recherche (sous forme d'une chaine a zero terminal).
    - le nom du systeme sur lequel la fonction doit commencer la recherche de l'acompte (sous la
      forme '\\NOM_NETBIOS') ou son adresse IP (sous la forme '\\xxx.xxx.xxx.xxx').
      Le systeme local peut etre designe par une chaine nulle.

   Si le principal de securite recherche n'est pas trouve sur le systeme specifie,
   LookupAccountName interrogera le controleur de domaine principal du systeme, puis tous les
   controleurs de domaine de confiance. Sur windows 2000 et XP, LookupAccountName cherchera
   dans tous les domaines de la foret windows 2000 (la fonction ne s'arretera pas a ceux
   declares explicitement "de confiance", comme sur windows NT.)

   En outre, LookupAccountName renvoie une variable detaillant le type de l'acompte trouve :
   User, groupe, domaine... Les constantes permettant de distinguer les
   differents types d'acomptes (SidTypeUser, SidTypeGroup, SidTypeAlias, etc.) sont declarees
   dans WinNT.h (=JwaWinNT.pas). (Voir la fonction SidType2Str)

   En cas d'echec de la fonction, GetLastError renvoie le numero de l'exception rencontree,
   mais en cas de reussite, LookupAccountName ne modifie pas GetLastError. (pas de
   ERROR_SUCCESS)


   NB : A partir d'ici, pour des raisons de place, il m'arrivera de designer les 'principaux de
        securites' par le mot 'acompte'. Certes, cette expression est tres imprecise, mais elle
        a l'avantage de ne prendre que 8 caracteres ;)

   Cette fonction est utilisable sur les systemes suivants :
     Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
     Serveurs: [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


BOOL LookupAccountName (                   // [out]    0 si erreur
  LPCTSTR        lpSystemName            , // [in]     Nom du systeme ou commencer la recherche
  LPCTSTR        lpAccountName           , // [in]     Nom de l'acompte recherche
  PSID           Sid                     , // [out]    Renvoie le SID de l'acompte recherche
  LPDWORD        cbSid                   , // [in,out] Taille du SID en octets
  LPTSTR         ReferencedDomainName    , // [out]    Nom de domaine de l'acompte trouve
  LPDWORD        cchReferencedDomainName , // [in,out] Taille du nom de domaine en octets
  PSID_NAME_USE  peUse                     // [out]    Retourne le type d'acompte trouve
) ;


  L'appelant doit allouer suffisamment de memoire pour les buffers pointes par Sid et
  ReferencedDomainName. La taille memoire allouee pour ces deux buffers doit etre transmise a la
  fonction grace a cbSid et cchReferencedDomainName. Si elle est insuffisante, la fonction
  echoue (en declenchant l'exception 122 = buffer insuffisant), et transmet l'espace memoire
  necessaire dans cbSid et cchReferencedDomainName.

------------------------------------------------------------------------------------------------


 Exemple : GetAccountSid
 ------------------------

  GetAccountSid utilise la fonction LookupAccountName pour renvoyer le SID d'un acompte a
  partir de son nom chaine.

  L'appelant devra liberer le PSid renvoye avec HeapFree apres utilisation.

  En cas d'erreur, la fonction renvoie NIL, une chaine 'NUL' pour StrDomain et 0 pour
  caSidType. Le code d'erreur est renvoye dans la variable caError. Il peut etre interprete a
  l'aide des constantes d'erreur windows, definies dans WinError.h (=JwaWinError.pas pour
  Delphi) Pour cette fonction, les plus utiles sont : ERROR_ACCESS_DENIED (=5),
  ERROR_NONE_MAPPED (=1332) et RPC_S_SERVER_UNAVAILABLE (=1722).

  Pour plus de simplicite d'utilisation, elles sont respectivement renommees ACCESS_DENIED,
  ACCOUNT_NOT_FOUND et SERVER_NOT_FOUND dans l'interface de cette unite.

*)


 Function GetAccountSid (StrSystemName : String  ;  // Nom du systeme ou commencer la recherche
                         StrAccountName: String  ;  // Nom de l'acompte recherche
                         Var StrDomain : String  ;  // Nom de domaine de l'acompte trouve
                         Var caSidType : Cardinal;  // Type d'acompte trouve
                         Var caError   : Cardinal)  // 0 si succes
                                       : PSID    ;  // retourne le SID de l'acompte recherche


 Var
   lpSid           : PSID   ; // PSID est defini dans WinNT.h (JwaWinNT.pas)
   lpstrDomainName : LPCSTR ; // <==> Pchar, defini dans WinType.h (=JwaWinType.pas)
   dwSidSize       : DWord  ; // <==> Cardinal, defini dans WinType.h (=JwaWinType.pas)
   dwDomainSize    : DWord  ;
   dwAccountType   : DWord  ;
   bSucces         : Boolean ;

 Begin
   StrDomain:= 'NUL' ;
   caSidType:= 0 ;
   caError  := 0 ;
   Result   := NIL ;

   lpSid          := NIL ;
   lpstrDomainName:= NIL ;
   dwSidSize      := 0 ;
   dwDomainSize   := 0 ;
   dwAccountType  := 0 ;
   bSucces        := False ;

   SetLastError (0) ;

   // On cherche a connaitre la taille de lpstrDomainName et de lpSid.
   // En appelant LookupAccountName avec une taille de buffer nulle, on declenche l'exception
   // 122, et la taille necessaire nous est renvoyee dans dwSidSize et dwDomainSize.
   bSucces := LookupAccountName (LPCSTR (StrSystemName), LPCSTR (StrAccountName), nil,
                                 dwSidSize, nil, dwDomainSize, dwAccountType) ;
   caError := GetLastError ;

   // Si tout ce passe comme prevu ...
   If caError = ERROR_INSUFFICIENT_BUFFER    // ERROR_INSUFFICIENT_BUFFER = 122
     Then Begin
      bSucces         := True ;
      // on alloue suffisamment de memoire pour lpSid et lpstrDomainName
      lpSid           := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwSidSize   ) ;
      lpstrDomainName := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwDomainSize) ;
     End
     Else bSucces := False ;

   If bSucces Then  // Si l'allocation a eu lieu ...
     If (lpSid <> nil) AND (lpstrDomainName <> NIL) Then  // et si l'allocation a reussi...
       Begin
        // Appel final de LookupAccountName - Cette fois ci, on affecte lpSid & lpstrDomainName.
        bSucces := LookupAccountName (LPCSTR (StrSystemName), LPCSTR (StrAccountName), lpSid,
                                      dwSidSize, lpstrDomainName, dwDomainSize, dwAccountType) ;
        If NOT bSucces Then caError := GetLastError ;
       End
       Else Begin
        bSucces := False ;
        caError := GetLastError ;
       End ;

   If bSucces Then   // Si le dernier appel a LookupAccountName a reussi ...
     Begin
      caError  := 0 ;
      StrDomain:= String (lpstrDomainName) ;
      caSidType:= Cardinal (dwAccountType) ;
      Result   := lpSid ;     // L'appelant devra penser a liberer Result avec HeapFree.
     End ;

   SetLastError (caError) ;

   // Liberation du pointeur lpstrDomainName.
   If lpstrDomainName <> NIL Then HeapFree (GetProcessHeap, 0, lpstrDomainName) ;
 End;


{-----------------------------------</LookupAccountName>---------------------------------------}








(*
================================================================================================
:::::::::::::::::::::::::::::::::::::   LookupAccountSid   :::::::::::::::::::::::::::::::::::::
================================================================================================

Description : (source : msdn)

   LookupAccountSid renvoie le nom chaine d'un principal de securite (designe par son SID), et
   le nom de domaine sur lequel ce principal a ete trouve.

   L'appelant doit fournir deux arguments :
   - Le SID de du principal de securite recherche.
   - le nom du systeme sur lequel la fonction doit commencer la recherche sous la forme
     '\\NOM_NETBIOS' ou son adresse IP sous la forme '\\xxx.xxx.xxx.xxx'. Le systeme local
     peut etre designe par une chaine nulle.

   En outre, LookupAccountSid renvoie une variable detaillant le type d'acompte trouve :
   User, groupe, domaine... Les constantes permettant de distinguer les differents types
   d'acomptes (SidTypeUser, SidTypeGroup, SidTypeAlias, etc. ) sont declarees dans WinNT.h
   (=JwaWinNT.pas). (Voir la fonction SidType2Str.)


   Cette fonction est utilisable sur les systemes suivants :
     Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
     Serveurs : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 BOOL LookupAccountSid  (                  // [out] 0 si erreur
   LPCTSTR       lpSystemName            , // [in]  Nom du systeme ou commencer la recherche
   PSID          lpSid                   , // [in]  SID recherche
   LPTSTR        lpName                  , // [out] renvoie le nom de l'acompte recherche
   LPDWORD       cchName                 , // [in,out] Taille du nom de l'acompte en octets
   LPTSTR        lpReferencedDomainName  , // [out] Nom de domaine de l'acompte trouve
   LPDWORD       cchReferencedDomainName , // [out] Taille du nom de domaine en octets
   PSID_NAME_USE peUse                     // [out] Type d'acompte trouve
 ) ;

 Rem : L'appelant devra allouer des buffers pour lpName et lpReferencedDomainName avant
       d'appeler la fonction, et les liberer apres utilisation. (cf HeapAlloc et HeapFree)

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


 Exemple : GetAccountName
 -------------------------

  GetAccountName renvoie le nom chaine d'un acompte (ou plus exactement d'un principal de
  securite NT) en utilisant LookupAccountSid.

  En cas d'erreur, la fonction renvoie une chaine 'NUL' et 0 pour caSidType.
  Le numero de l'exception qui vient de se produire est renvoye dans la variable caError.

  Il peut etre interprete a l'aide des constantes d'erreur windows, definies dans WinError.h
  (=JwaWinError.pas pour delphi). Pour cette fonction, les plus utiles sont :
  ERROR_ACCESS_DENIED (=5), ERROR_NONE_MAPPED (=1332) et RPC_S_SERVER_UNAVAILABLE (=1722).

  Pour plus de simplicite d'utilisation, elles sont respectivement renommees ACCESS_DENIED,
  ACCOUNT_NOT_FOUND et SERVER_NOT_FOUND dans l'interface de cette unite.

*)


Function GetAccountName (StrSystemName : String  ;  // Nom du systeme ou commencer la recherche
                         lpSid         : PSID    ;  // SID de l'acompte
                         Var StrDomain : String  ;  // Nom domaine de l'acompte trouve
                         Var caSidType : Cardinal;  // Renvoie le type de l'acompte trouve
                         Var caError   : Cardinal)  // 0 si succes
                                       : String  ;  // Nom chaine de l'acompte recherche
                                                    // ('NUL' si echec )

 Var
   StrAccountName : LPCSTR ;
   lpstrDomainName: LPCSTR ;
   dwAccountSize  : DWord  ;
   dwDomainSize   : DWord  ;
   dwAccountType  : DWord  ;
   bSucces        : Boolean;

 Begin
   StrDomain := 'NUL' ;
   caSidType := 0     ;
   caError   := 0     ;
   Result    := 'NUL' ;

   StrAccountName := NIL ;
   lpstrDomainName:= NIL ;
   dwAccountSize  := 0 ;
   dwDomainSize   := 0 ;
   dwAccountType  := 0 ;
   bSucces        := False ;

   SetLastError (0) ;

   // On cherche a connaitre la taille de lpstrDomainName et de lpSid.
   bSucces := LookupAccountSid (LPCSTR (StrSystemName), lpSid, NIL, dwAccountSize, NIL,
                                dwDomainSize, dwAccountType) ;
   caError := Cardinal (GetLastError) ;

   // Si tout ce passe comme prevu, le buffer est trop petit...
   If caError = ERROR_INSUFFICIENT_BUFFER Then   // ERROR_INSUFFICIENT_BUFFER = 122
     Begin
      bSucces  := True ;
      StrAccountName  := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwAccountSize) ;
      lpstrDomainName := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwDomainSize ) ;
     End
     Else bSucces := False ;

   If bSucces Then   // Si l'allocation a eu lieu ..
     If (StrAccountName <> nil) AND (lpstrDomainName <> NIL) Then  // Si l'allocation a reussi
       Begin
        // Appel final de LookupAccountSid - Cette fois ci, on affecte StrAccountName
        // & lpstrDomainName.
        bSucces:= LookupAccountSid (LPCSTR(StrSystemName), lpSid, StrAccountName,dwAccountSize,
                                    lpstrDomainName, dwDomainSize, dwAccountType) ;
        If NOT bSucces Then caError := GetLastError ;
       End
       Else Begin
        bSucces := False        ;
        caError := GetLastError ;
       End ;

   If bSucces Then // Si le dernier appel a LookupAccountSid a reussi ...
     Begin
      caError   := 0 ;
      StrDomain := String (lpstrDomainName) ;
      caSidType := Cardinal (dwAccountType) ;
      Result    := String (StrAccountName)  ;
     End ;

   SetLastError (0) ;

   // Liberation de la memoire allouee :
   If lpstrDomainName <> NIL Then HeapFree (GetProcessHeap, 0, lpstrDomainName) ;
   If StrAccountName <> NIL Then HeapFree (GetProcessHeap, 0, StrAccountName) ;
End;

{-------------------------------------</LookupAccountSid>--------------------------------------}








(*

================================================================================================
:::::::::::::::::::::::::::::::::::::     Str2Sid     ::::::::::::::::::::::::::::::::::::::::::
================================================================================================


Description : (source : msdn)

  Les SIDs peuvent etre stockes sous forme binaire (dans un PSid) ou sous forme de chaine de
  caracteres. La fonction ConvertStringSidToSid convertit un SID chaine en SID binaire.

  Cette fonction est utilisable sur les systemes suivants :
     Clients : [Windows XP], [Windows 2000 Professional]
     Serveurs : [Windows Server 2003], [Windows 2000 Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Sddl.h
 Library         : Use Advapi32.lib
 Unite delphi   : JwaSddl.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 BOOL ConvertStringSidToSid (
   LPCTSTR StringSid ,    // [in]  Le SID chaine
   PSID*   Sid            // [out] Le SID binaire
 ) ;

 Rem : La fonction ConvertStringSidToSid alloue elle meme le buffer necessaire pour Sid.
       L'appelant doit cependant penser a liberer ce buffer apres utilisation (cf : HeapFree)

------------------------------------------------------------------------------------------------

 Exemple : Str2Sid
 -----------------

 Str2Sid utilise ConvertStringSidToSid pour transformer un SID chaine en SID binaire.
 En cas d'erreur, la fonction renvoie NIL.
 Si la fonction reussit, l'appelant devra penser a liberer le PSid renvoye avec HeapFree apres
 utilisation.

*)


Function Str2Sid (StrSid : String)
                         : PSID  ;   // NIL si erreur

 Var
   bSucces  : Boolean;
   lpSid    : PSID   ;
   lpstrSid : LPCSTR ;

 Begin
   Result  := NIL  ;
   bSucces := False;
   lpSid   := NIL  ;
   lpstrSid:= NIL  ;

   If (StrSid <> '') AND (StrSid <> ' ')
     Then Begin
      lpstrSid := LPCSTR (StrSid) ;
      bSucces  := ConvertStringSidToSid (lpstrSid, lpSid) ;
     End ;

     { 3 petites choses importantes :
       . ConvertStringSidToSid alloue elle meme l'espace memoire necessaire a lpSid. Il n'est
         donc pas necessaire d'allouer de la memoire avant d'appeler la fonction.
       . Il est absolument necessaire de NE PAS ALLOUER de memoire, sans quoi l'adresse de
         l'espace reserve (stocke dans lpSid) sera perdu lors de l'appel a
         ConvertStringSidToSid (parce que lpSid est modifie par la fonction), et il sera
         ensuite impossible de liberer l'espace anciennement designe par lpSid.
       . L'appelant devra liberer le pointeur lpSid apres usage.
     }

   If bSucces AND (lpSid <> NIL)
     Then Result := lpSid ;
 End ;

{----------------------------------------</Str2Sid>--------------------------------------------}






(*
================================================================================================
:::::::::::::::::::::::::::::::::::::     Sid2Str     ::::::::::::::::::::::::::::::::::::::::::
================================================================================================


  La fonction ConvertSidToStringSid convertit un SID binaire (un PSid) en SID chaine.

  Cette fonction est utilisable sur les systemes suivants :
     Clients : [Windows XP], [Windows 2000 Professional]
     Serveurs: [Windows Server 2003], [Windows 2000 Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Sddl.h
 Library         : Use Advapi32.lib
 Unite delphi   : JwaSddl.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  BOOL ConvertSidToStringSid (
    PSID     Sid         ,   // Le SID binaire
    LPTSTR*  StringSid       // Le SID chaine
  ) ;

 Rem : La fonction alloue elle meme la memoire pour le buffer StringSid, il faut donc que
       l'appelant la libere avec HeapFree quand il a fini de l'utiliser.
------------------------------------------------------------------------------------------------

 Exemple : Sid2Str
 ------------------

 La fonction Sid2Str utilise ConvertSidToStringSid pour convertir un SID binaire en SID chaine.
 En cas d'erreur, la fonction renvoie la chaine 'NUL'.

*)

Function Sid2Str (lpSid : PSID) : String ;

 Var
   bSucces  : Boolean ;
   lpstrSid : LPCSTR  ;

 Begin
   Result   := 'NUL' ;
   bSucces  := False ;
   lpstrSid := NIL   ;


   If (lpSid <> nil)
     Then bSucces := ConvertSidToStringSid (lpSid, lpstrSid) ;
     // Pas besoin d'allouer de la memoire pour lpstrSid : c'est la fonction qui s'en occupe...

   If bSucces AND (lpstrSid <> NIL)
     Then Result := String (lpstrSid)
     Else Result := 'NUL' ;

   // Liberation du pointeur lpstrSid !
   If lpstrSid <> NIL Then HeapFree (GetProcessHeap, 0, lpstrSid) ;
 End ;

{----------------------------------------</Sid2Str>--------------------------------------------}





(*
================================================================================================
:::::::::::::::::::::::::::::::::::::::    SidType2Str      ::::::::::::::::::::::::::::::::::::
================================================================================================


CETTE FONCTION NE CORRESPOND A AUCUNE FONCTION DE L API WINDOWS.

Elle permet juste de differencier les differents types d'acomptes (= de principaux de securite
windows.) grace aux constantes declarees dans WinNT.h (=JwaWinNT.pas)

*)

Function SidType2Str (caSidType : Cardinal) : String ;

 Begin
   Case caSidType of
    SidTypeUser           : Result :=  'User'               ; //  =1
    SidTypeGroup          : Result :=  'Group'              ; //  =2
    SidTypeDomain         : Result :=  'Domain'             ; //  =3
    SidTypeAlias          : Result :=  'Alias'              ; //  =4
    SidTypeWellKnownGroup : Result :=  'WellKnownGroup'     ; //  =5
    SidTypeDeletedAccount : Result :=  'DeletedAccount'     ; //  =6
    SidTypeInvalid        : Result :=  'Invalid'            ; //  =7
    SidTypeUnknown        : Result :=  'Unknown'            ; //  =8
   Else
    Result :=  'Unknown'                     ;
   End ;
 End ;

{--------------------------------------</SidType2Str>------------------------------------------}

END.






