
{----------------------------------------------------------------------------------------------}
{                                                                                              }
{ Ce code est plus fait pour etre lu que pour etre execute. Il a ete cree dans le but de servir}
{ d'aide memoire plus tard. Il marche (sans plus), mais son but est uniquement demonstratif.   }
{                                                                                              }
{ Beaucoup de constantes deja declarees dans les headers Windows sont redeclarees ici, dans le }
{ seul but de faciliter la lecture de ce source.                                               }
{                                                                                              }
{ Vous pouvez librement utiliser, modifier ou diffuser ce code tant que vous restez dans une   }
{ logique de partage et de non-profit.                                                         }
{                                                                                              }
{ Pour toutes remarques --> phaz at dune2 point info                                           }
{                                                                                              }
{    ~ Phaz ~                                                                                  }
{                                                                                              }
{----------------------------------------------------------------------------------------------}




UNIT LookupLuid ;

INTERFACE
 Uses
   JwaWintype;

 Const
   // Ces constantes sont deja declarees dans JwaWinNT.pas
   // (les redeclarer ici n'est pas obligatoire)
   // Privileges NT :
   SE_CREATE_TOKEN_NAME        = 'SeCreateTokenPrivilege';
   SE_ASSIGNPRIMARYTOKEN_NAME  = 'SeAssignPrimaryTokenPrivilege';
   SE_LOCK_MEMORY_NAME         = 'SeLockMemoryPrivilege';
   SE_INCREASE_QUOTA_NAME      = 'SeIncreaseQuotaPrivilege';
   SE_UNSOLICITED_INPUT_NAME   = 'SeUnsolicitedInputPrivilege';
   SE_MACHINE_ACCOUNT_NAME     = 'SeMachineAccountPrivilege';
   SE_TCB_NAME                 = 'SeTcbPrivilege';
   SE_SECURITY_NAME            = 'SeSecurityPrivilege';
   SE_TAKE_OWNERSHIP_NAME      = 'SeTakeOwnershipPrivilege';
   SE_LOAD_DRIVER_NAME         = 'SeLoadDriverPrivilege';
   SE_SYSTEM_PROFILE_NAME      = 'SeSystemProfilePrivilege';
   SE_SYSTEMTIME_NAME          = 'SeSystemtimePrivilege';
   SE_PROF_SINGLE_PROCESS_NAME = 'SeProfileSingleProcessPrivilege';
   SE_INC_BASE_PRIORITY_NAME   = 'SeIncreaseBasePriorityPrivilege';
   SE_CREATE_PAGEFILE_NAME     = 'SeCreatePagefilePrivilege';
   SE_CREATE_PERMANENT_NAME    = 'SeCreatePermanentPrivilege';
   SE_BACKUP_NAME              = 'SeBackupPrivilege';
   SE_RESTORE_NAME             = 'SeRestorePrivilege';
   SE_SHUTDOWN_NAME            = 'SeShutdownPrivilege';
   SE_DEBUG_NAME               = 'SeDebugPrivilege';
   SE_AUDIT_NAME               = 'SeAuditPrivilege';
   SE_SYSTEM_ENVIRONMENT_NAME  = 'SeSystemEnvironmentPrivilege';
   SE_CHANGE_NOTIFY_NAME       = 'SeChangeNotifyPrivilege';
   SE_REMOTE_SHUTDOWN_NAME     = 'SeRemoteShutdownPrivilege';
   SE_UNDOCK_NAME              = 'SeUndockPrivilege';
   SE_SYNC_AGENT_NAME          = 'SeSyncAgentPrivilege';
   SE_ENABLE_DELEGATION_NAME   = 'SeEnableDelegationPrivilege';
   SE_MANAGE_VOLUME_NAME       = 'SeManageVolumePrivilege';

   // Ces constantes sont deja declarees dans JwaWinError.pas. Elles sont redefinies ici avec un
   // nom plus court et plus facile a retenir. (ce n'est pas obligatoire)
   ACCESS_DENIED     = 5    ;            // Initialement ERROR_ACCESS_DENIED
   SERVER_NOT_FOUND  = 1722 ;            // initialement RPC_S_SERVER_UNAVAILABLE
   ACCOUNT_NOT_FOUND = 1332 ;            // initialement ERROR_NONE_MAPPED

   // Utile pour HeapAlloc - Deja declare dans JwaWinNT.pas
   HEAP_ZERO_MEMORY  = $8        ;



 // Exemple d'appel de "LookupPrivilegeValue" :
 // convertit un privilege chaine en LUID.
 Function Privilege2Luid (strSystem        : String  ;
                          strPrivilegeName : String  ;
                          VAR caError      : Cardinal)
                                           : LUID    ;

 // Exemple d'appel de la fonction "LookupPrivilegeName" :
 // convertit un LUID en privilege chaine.
 Function Luid2Privilege (strSystem   : String  ;
                          rLuid       : LUID    ;
                          VAR caError : Cardinal)
                                      : String  ;

 // Exemple d'appel de la fonction "LookupPrivilegeDisplayName" :
 // convertit un privilege chaine en une chaine decrivant ce privilege dans la langue de
 // l'utilisateur.
 Function Privilege2UserStr (strSystem    : String   ;
                             strPrivilege : String   ;
                             VAR caLang   : Cardinal ;
                             VAR caError  : Cardinal )
                                          : String   ;


IMPLEMENTATION
 Uses
   JwaWinError,
   JwaWinBase ;


(*
================================================================================================
:::::::::::::::::::::::::::::::      LookupPrivilegeValue      :::::::::::::::::::::::::::::::::
================================================================================================


Description : (source : msdn)

 LookupPrivilegeValue renvoie le LUID d'un privilege (de type chaine) sur un systeme donne. (Il
 faut specifier le systeme, puisqu'un LUID est unique sur un systeme et non sur l'ensemble des
 ordinateurs du reseaux)

 On peut specifier le systeme en utilisant le nom de domaine NT de l'ordinateur sous la forme
 '\\NOM_NETBIOS', ou directement avec son IP sous la forme '\\xxx.xxx.xxx.xxx'. Une chaine nulle
 designe le systeme local.

 En cas de reussite, la fonction renvoie vrai. En cas d'erreur, elle renvoie faux, et il faut
 appeler GetLastError pour avoir plus de details.

 Cette fonction est utilisable sur les systemes suivants :
  Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
  Serveur : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

BOOL LookupPrivilegeValue (     // [out] 0 si erreur
  LPCTSTR lpSystemName,         // [in]  Nom du systeme (chaine nulle pour le systeme local)
  LPCTSTR lpName,               // [in]  Nom du privilege
  PLUID   lpLuid                // [out] Pointe vers le LUID du privilege
);

typedef struct LUID {
  DWORD LowPart;                // <==> 32 bits non signes <==> Cardinal en Delphi
  LONG  HighPart;               // <==> 32 bits signes <==> Longint en Delphi
}

------------------------------------------------------------------------------------------------

 Exemple : Privilege2Luid
 -------------------------

 La fonction Privilege2Luid renvoie le LUID d'un privilege sur un systeme donne en utilisant
 LookupPrivilegeValue.

 Si l'appel reussit, la fonction renvoie un LUID valide, et le code d'erreur 0. Si l'appel
 echoue, Privilege2Luid renvoie 0, et le code d'erreur adapte (ERROR_NONE_MAPPED,
 RPC_S_SERVER_UNAVAILABLE, ERROR_ACCESS_DENIED, etc...)

 Pour plus de simplicite, il est souvent possible d'utiliser ACCOUNT_NOT_FOUND, SERVER_NOT_FOUND
 et ACCESS_DENIED pour interpreter le code de sortie de cette fonction.

 *)

Function Privilege2Luid (strSystem        : String   ; // nom du systeme
                         strPrivilegeName : String   ; // nom chaine du privilege
                         VAR caError      : Cardinal ) // 0 si reussite
                                          : LUID     ; // LUID du privilege
                                                       // Renvoie 0 en cas d'erreur

 Var
   rPrivilegeLuid : LUID    ;   // defini dans JwaWintype.pas
   bSucces        : Boolean ;

 Begin
   caError  := 0 ;
   bSucces  := False ;
   Result.LowPart  := 0 ;
   Result.HighPart := 0 ;
   rPrivilegeLuid.LowPart  := 0 ;
   rPrivilegeLuid.HighPart := 0 ;

   SetLastError (0) ;

   bSucces := LookupPrivilegeValue (LPCSTR (strSystem), LPCSTR (strPrivilegeName),
                                    rPrivilegeLuid) ;
   If bSucces Then
     Begin
       Result := rPrivilegeLuid ;
       caError  := 0 ;
     End
     Else caError := GetLastError ;

   SetLastError (caError) ;
 End ;

{----------------------------------</LookupPrivilegeValue>-------------------------------------}










{
================================================================================================
:::::::::::::::::::::::::::::::::::   LookupPrivilegeName  :::::::::::::::::::::::::::::::::::::
================================================================================================

 LookupPrivilegeName renvoie le nom chaine d'un privilege a partir de son LUID sur un systeme
 donne.

 Cette fonction est utilisable sur les systemes suivants :
  Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
  Serveur : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  BOOL LookupPrivilegeName (     // 0 si erreur
    LPCTSTR lpSystemName,        // [in] Nom du systeme
    PLUID   lpLuid,              // [in] Pointeur vers un LUID
    LPTSTR  lpName,              // [out] Nom chaine du privilege designe par le LUID
    LPDWORD cchName              // [in,out] taille du buffer pour lpName en octets (zero
  );                             //          terminal exclu)


 Rem : L'appelant devra allouer suffisamment d'espace memoire pour le buffer pointe par lpName,
       et passer la taille de l'espace disponible a la fonction grace a cchName. Si le buffer
       est trop petit pour contenir le nom de privilege, LookupPrivilegeName declenche
       l'exception 122, et renvoie la taille memoire necessaire dans cchName.

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  Remarque pour ceux qui n'ont pas, ou tres peu d'experience avec les APIs windows :


  L'appelant doit allouer suffisamment de memoire pour le buffer pointe par lpName. La taille
  memoire allouee pour ce buffer doit etre transmise a la fonction grace a cchName. Si elle
  est insuffisante pour contenir le nom du privilege, la fonction echoue en declenchant
  l'exception 122 (= buffer insuffisant), et transmet l'espace memoire necessaire dans cchName.

  Ce mecanisme est commun a de nombreuses fonctions de l'API windows.

  Concretement, la meilleure technique consiste a appeler une fois la fonction "a blanc", en
  specifiant 0 comme taille de buffer. Un tel appel provoquera inevitablement un echec de la
  fonction, l'exception 122 (ERROR_INSUFFICIENT_BUFFER), et surtout, la transmission a
  l'appelant de la taille buffer necessaire dans une variable prevue a cet effet.
  Maintenant que l'espace memoire necessaire est connu, il ne nous reste plus qu'a allouer
  suffisamment de memoire pour le(s) buffer(s), puis a appeler la fonction une deuxieme et
  derniere fois.
  Si la fonction le permet, on evitera de specifier l'adresse de notre buffer lors du premier
  appel (on peut souvent mettre le pointeur NIL a la place)

  Notez qu'il est tres important de liberer l'espace memoire alloue (avec HeapFree) apres
  utilisation.

------------------------------------------------------------------------------------------------

 Exemple : Luid2Privilege
 -------------------------


 Luid2Privilege renvoie le nom d'un privilege a partir de son LUID en utilisant
 LookupPrivilegeName.

 Si l'appel reussit, Luid2Privilege renvoie le nom du privilege et caError est egal a 0.
 Si l'appel echoue Luid2Privilege renvoie la chaine 'NUL' (si vous preferez une chaine nulle,
 vous n'avez qu'a changer mon code) et le numero de l'exception correspondante dans caError.



}

Function Luid2Privilege (strSystem   : String  ;  // nom du systeme
                         rLuid       : LUID    ;  // LUID du privilege
                         VAR caError : Cardinal)  // 0 si succes
                                     : String  ;  // renvoie le nom chaine du privilege


 Var
   lpstrPrivilegeName : LPCSTR  ; // <==> Pchar, defini dans WinType.h (=JwaWinType.pas)
   dwPrivilegeSize    : DWord   ; // <==> Cardinal, defini dans WinType.h (=JwaWinType.pas)
   bSucces            : Boolean ;


 Begin
   Result  := 'NUL' ;
   bSucces := False ;
   lpstrPrivilegeName := NIL ;
   dwPrivilegeSize    := 0   ;

   SetLastError (0) ;

   // Recuperation de l'espace memoire necessaire pour lpstrPrivilegeName, grace a un appel
   // a LookupPrivilegeName avec un buffer de 0 octet
   bSucces := LookupPrivilegeName (LPCSTR (strSystem), rLuid, NIL, dwPrivilegeSize) ;
   caError := GetLastError ;

   // Il est normal de rencontrer l'exception 122 (= ERROR_INSUFFICIENT_BUFFER)
   If caError = ERROR_INSUFFICIENT_BUFFER Then
     Begin
      bSucces := True ;
      // Allocation de dwPrivilegeSize octets pour lpstrPrivilegeName
      lpstrPrivilegeName := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwPrivilegeSize ) ;
     End ;


   If bSucces Then
     If lpstrPrivilegeName <> NIL
       // Appel Final de LookupPrivilegeName
       Then bSucces := LookupPrivilegeName (LPCSTR (strSystem), rLuid, lpstrPrivilegeName,
                                            dwPrivilegeSize)
       Else Begin
         bSucces := False ;
         caError := GetLastError ;
       End ;

   If bSucces Then
     Begin
      Result  := String (lpstrPrivilegeName) ;
      caError := 0 ;
     End ;

   SetLastError (caError) ;

   // Liberation du pointeur lpstrPrivilegeName.
   If lpstrPrivilegeName <> NIL Then HeapFree (GetProcessHeap, 0, lpstrPrivilegeName) ;
 End ;

{----------------------------------</LookupPrivilegeName>--------------------------------------}









{
================================================================================================
:::::::::::::::::::::::::::::::::   LookupPrivilegeDisplayName  ::::::::::::::::::::::::::::::::
================================================================================================


 LookupPrivilegeDisplayName attend un nom de privilege (de type chaine) en argument, et
 renvoie une chaine de caracteres designant ce privilege, formule de maniere comprehensible par
 l'utilisateur, dans la langue par defaut du systeme.

 Par exemple : "SE_DEBUG_NAME" donnera "Deboguer des programmes" sur un systeme francais

 En plus du privilege souhaite, il faut specifier a la fonction sur quel systeme on
 veut effectuer l'affichage, afin que windows sache en quelle langue decrire le privilege.


 Cette fonction est utilisable sur les systemes suivants :
  Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
  Serveur : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas ( + JwaWinType pour les LPTSTR et les DWord ).
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


  BOOL LookupPrivilegeDisplayName (  // [out] Renvoie 0 en cas d'echec.
    LPCTSTR lpSystemName,            // [in]  Systeme ou s'effectue la conversion (nul = local)
    LPCTSTR lpName,                  // [in]  Nom chaine du privilege
    LPTSTR  lpDisplayName,           // [out] Nom affichable du privilege
    LPDWORD cchDisplayName,          // [in,out] Taille de lpDisplayName en octets, sans le zero
                                     //          terminal
    LPDWORD lpLanguageId             // [out] Contient le code de langage de la chaine renvoyee
  );                                 //       (cf LANG_ID & Code de Langage)

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 Remarque : Que la sortie de LookupPrivilegeDisplayName soit au standard Unicode ou ANSI n'y
            change rien : Les accents ne s'affichent pas correctement dans la console windows.

            --> Afin d'obtenir un affichage correct, il faut convertir la chaine en ASCII avant
            de l'afficher. (cf ANSI2ASCII & ASCII2ANSI declarees dans ANSI_ASCII.pas)


 NB : Liste non exhaustive des codes de langages :

   *-----------------------------------*   *-----------------------------------------*
   *  Language      LANGID             *   *       Language                  LANGID  *
   *-----------------------------------*   *-----------------------------------------*
   *  English       0409 (By Default)  *   *       Russian                   0419    *
   *  French        040c               *   *       Czech                     0405    *
   *  Spanish       0c0a               *   *       Greek                     0408    *
   *  Italian       0410               *   *       Portuguese                0816    *
   *  Swedish       041D               *   *       Turkish                   041f    *
   *  Dutch         0413               *   *       Japanese                  0411    *
   *  Brazilian     0416               *   *       Korean                    0412    *
   *  Finnish       040b               *   *       German                    0407    *
   *  Norwegian     0414               *   *       Chinese (Simplified)      0804    *
   *  Danish        0406               *   *       Chinese (Traditional)     0404    *
   *  Hungarian     040e               *   *       Arabic                    0401    *
   *  Polish        0415               *   *       Hebrew                    040d    *
   *-----------------------------------*   *-----------------------------------------*



------------------------------------------------------------------------------------------------

 Exemple : Privilege2UserStr
 --------------------------------

 Privilege2UserStr utilise LookupPrivilegeDisplayName pour renvoyer le nom 'affichable' d'un
 privilege sur un systeme donne.



}

 Function Privilege2UserStr (strSystem            : String  ; // Nom du systeme
                             strPrivilege         : String  ; // Nom chaine du privilege
                             VAR caLang           : Cardinal; // LangID du systeme
                             VAR caError          : Cardinal) // 0 si succes
                                                  : String  ; // Nom 'affichable' du privilege
                                                              // = 'NUL' si echec

 Var	
   lpstrPrivAffichable  : LPTSTR ;
   dwSizePrivAffichable : DWORD  ;
   dwLangId : DWORD   ;
   bSucces  : Boolean ;

 Begin
   Result  := 'NUL' ;
   dwSizePrivAffichable := 0     ;
   lpstrPrivAffichable  := NIL   ;
   caLang  := 0 ;
   caError := 0 ;
   bSucces := False ;
   dwLangId := 0 ;

   SetLastError (0) ;

   // On appelle d'abord LookupPrivilegeDisplayName avec un buffer de 0 octet. On peut ainsi
   // recuperer la taille necessaire pour lpstrPrivAffichable dans SizeOutStr.
   bSucces := LookupPrivilegeDisplayName (LPCSTR (strSystem), LPCSTR (strPrivilege), NIL,
                                          dwSizePrivAffichable, dwLangId) ;
   caError := GetLastError ;

   // Normalement, le buffer devrait etre trop petit
   If caError = ERROR_INSUFFICIENT_BUFFER Then           // ERROR_INSUFFICIENT_BUFFER = 122
     Begin
      bSucces := True ;
      caError := 0 ;
      // On alloue un buffer suffisant pour lpstrPrivAffichable
      lpstrPrivAffichable := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, dwSizePrivAffichable);
     End ;

   If bSucces Then
     If lpstrPrivAffichable <> NIL
       // Appel final de LookupPrivilegeDisplayName
       Then bSucces := LookupPrivilegeDisplayName (LPCSTR (strSystem),LPCSTR (strPrivilege),
                        lpstrPrivAffichable, dwSizePrivAffichable, dwLangId)
       Else Begin
        caError := GetLastError ;
        bSucces := False ;
       End ;

   If bSucces Then
     Begin
      caLang  := Cardinal (dwLangId) ;
      caError := 0 ;
      Result  := String (lpstrPrivAffichable) ;
     End ;

   SetLastError (caError) ;

   // On libere le pointeur lpstrPrivAffichable :
   If lpstrPrivAffichable <> NIL Then HeapFree (GetProcessHeap, 0, lpstrPrivAffichable) ;
 End ;

{--------------------------------</LookupPrivilegeDisplayName>---------------------------------}


END.
