
{----------------------------------------------------------------------------------------------}
{                                                                                              }
{ Ce code est plus fait pour etre lu que pour etre execute. Il a ete cree dans le but de servir}
{ d'aide memoire plus tard. Il marche (sans plus), mais son but est uniquement demonstratif.   }
{                                                                                              }
{ Beaucoup de constantes deja declarees dans les headers Windows sont redeclarees ici, dans le }
{ seul but de faciliter la lecture de ce source.                                               }
{                                                                                              }
{ Vous pouvez librement utiliser, modifier ou diffuser ce code tant que vous restez dans une   }
{ logique de partage et de non-profit.                                                         }
{                                                                                              }
{ Pour toutes remarques --> phaz at dune2 point info                                           }
{                                                                                              }
{    ~ Phaz ~                                                                                  }
{                                                                                              }
{----------------------------------------------------------------------------------------------}



UNIT LookupPrivileges;


INTERFACE
 Uses
   JwaWintype;

 // Exemple d'appel de la fonction "PrivilegeCheck" :
 // Teste si un privilege donne est active ou non dans le Token du process specifie
 Function PrivilegeEnabled (hProcess        : Handle  ;
                            strPrivilegeName: String  ;
                            VAR caError     : Cardinal)
                                            : Boolean ;

 // Exemple d'appel de la fonction "AdjustTokenPrivileges" :
 // Active ou desactive un privilege donne dans le Token du process specifie
 Function SetPrivilegeAttribute (hProcess        : Handle  ;
                                 strPrivilegeName: String  ;
                                 bPrivilegeState : Boolean ;
                                 VAR Error       : Cardinal)
                                                 : boolean ;

                                                
IMPLEMENTATION
 Uses
   JwaWinBase,
   JwaWinError,
   JwaWinnt,
   LookupLuid ; 

 Const
   HEAP_ZERO_MEMORY   = $8        ;         // Constante deja definie dans JwaWinNT
                                            // (utile pour HeapAlloc.)



(*
================================================================================================
:::::::::::::::::::::::::::::::::::     PrivilegeCheck     :::::::::::::::::::::::::::::::::::::
================================================================================================

 PrivilegeCheck verifie dans un "Access Token" donne si les privileges specifies sont actives ou
 non.

 Le token doit prealablement avoir ete ouvert avec les droits d'acces TOKEN_QUERY. (sinon,
 l'acces sera refuse).

 Si la fonction reussit, elle renvoie vrai. Si elle echoue, elle renvoie faux, et il faut
 appeler GetLastError pour connaitre le numero de l'exception declenchee.

 Cette fonction est utilisable sur les systemes suivants :
  Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
  Serveur : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas ( + JwaWinNT.pas pour PPrivilegeSet).
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  BOOL PrivilegeCheck (                   // [out] 0 si erreur
    HANDLE         ClientToken,           // [in]  Handle vers le Token souhaite
    PPRIVILEGE_SET RequiredPrivileges,    // [in]  Contient la liste des privileges a tester
    LPBOOL         pfResult               // [out] Resultat du test : 0 si privilege desactive



 Les privileges a verifier sont transmis a la fonction via une variable de type PRIVILEGE_SET.
 (PPRIVILEGE_SET est un pointeur vers cette structure, declaree en delphi dans JwaWinNT.pas).

  typedef struct PRIVILEGE_SET {
    DWORD PrivilegeCount;                           // Nombre de privileges stockes.
    DWORD Control;                                  // Voir plus bas
    LUID_AND_ATTRIBUTES Privilege [ANYSIZE_ARRAY];
  };

  typedef struct _LUID_AND_ATTRIBUTES {
    LUID Luid;
    DWORD Attributes;
  };


 Le champ control de la structure PRIVILEGE_SET sert quand plusieurs privileges sont passes a
 la fonction :
  - Si on lui affecte la valeur PRIVILEGE_SET_ALL_NECESSARY, alors tous les privileges doivent
    etre actives pour que PrivilegeCheck renvoie vrai.
  - Si on met ce champ a 0, il suffit qu'un seul des privileges specifies soit active pour que
    PrivilegeCheck renvoie vrai.

------------------------------------------------------------------------------------------------

 Exemple : PrivilegeEnabled
 ---------------------------	


  La fonction PrivilegeEnabled utilise PrivilegeCheck pout tester si un privilege specifie est
  active ou non dans le Token du process specifie. PrivilegeEnabled ne teste qu'un seul
  privilege a la fois.

  Si la fonction reussit, caError est egal a 0 et PrivilegeEnabled renvoie l'etat du privilege
  specife : vrai pour active et faux pour desactive.
  Si la fonction echoue, caError contient le numero de l'exception declenchee et
  PrivilegeEnabled renvoie faux.

*)



Function PrivilegeEnabled (hProcess         : Handle  ; // Handle vers le process souhaite.
                           strPrivilegeName : String  ; // Nom chaine du privilege a tester
                           VAR caError      : Cardinal) // Code de sortie. 0 si succes.
                                            : Boolean ; // Etat du privilege specifie :
                                                        // VRAI si active et FAUX si desactive

 Var
   hToken  : Handle  ;
   bSucces : Boolean ;
   lpPrivilegeSet : PPRIVILEGE_SET ;  // Declare dans JwaWinNT.pas
   lbPrivEnabled  : longBool ;

 Begin
   caError := 0 ;
   hToken  := 0 ;
   Result  := False ;
   lbPrivEnabled  := False ;
   lpPrivilegeSet := NIL   ;

   SetLastError (0) ;

   // Ouverture du Token avec les droits TOKEN_QUERY
   bSucces := OpenProcessToken (hProcess, TOKEN_QUERY, hToken)  ;

   If bSucces      // Allocation de suffisamment de memoire pour 1 privilege. 
     Then lpPrivilegeSet := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, sizeof (PRIVILEGE_SET))
     Else caError  := GetLastError ;

   If bSucces Then
     If lpPrivilegeSet <> NIL Then
       Begin
        lpPrivilegeSet^.PrivilegeCount := 1 ;
        // on recupere le LUID du privilege sur le systeme local ('' designe le systeme local)
        lpPrivilegeSet^.Privilege [0].Luid := Privilege2LUID ('', strPrivilegeName, caError) ;
        If caError <> 0 Then bSucces := False ;
       End
       Else Begin
        bSucces := False ;
        caError := GetLastError ;
       End ;

   If bSucces Then
     Begin
      // Appel de PrivilegeCheck, lbPrivEnabled contient vrai si le privilege est active
      bSucces := PrivilegeCheck (hToken, lpPrivilegeSet, lbPrivEnabled) ;
      If bSucces Then
        Begin
         If lbPrivEnabled Then Result := True ;
         caError := 0 ;
        End
        Else caError := GetLastError ;
     End ;

   SetLastError (caError) ;

   // Liberation des pointeurs et handles
   If lpPrivilegeSet <> NIL Then HeapFree (GetProcessHeap, 0, lpPrivilegeSet) ;
   If hToken <> 0 Then CloseHandle (hToken) ;
 End ;

{-------------------------------------</PrivilegeCheck>----------------------------------------}









(*
================================================================================================
::::::::::::::::::::::::::::::::::: AdjustTokenPrivileges  :::::::::::::::::::::::::::::::::::::
================================================================================================


 AdjustTokenPrivileges permet de modifier les attributs associes aux privileges d'un Token
 donne. Ce Token doit prealablement avoir ete ouvert avec les droits TOKEN_ADJUST_PRIVILEGES.

 Chaque process possedant une copie distincte de son Access Token, la modification des
 privileges d'un Token donne ne se propagera pas aux autres process.

 Attention, par defaut toutes les threads d'un process heritent de son Access Token. Cela
 signifie que si vous activez un privilege pour une thread, il sera active pour toutes les
 threads.
 Pour affecter une copie distincte du Token a une thread, utilisez la fonction ImpersonateSelf.

 Si l'etat d'au moins un des privileges passes en argument a AdjustTokenPrivileges est modifie,
 la fonction renvoie Vrai. Attention : Cela ne signifie pas que tous les privileges specifies
 ont etes modifies !
 GetLastError renvoie ERROR_SUCCESS si tous les privileges ont etes mofifies et
 NOT_ALL_ASSIGNED dans le cas inverse.


 Cette fonction est utilisable sur les systemes suivants :
  Clients : [Windows XP], [Windows 2000 Professional], [Windows NT Workstation]
  Serveur : [Windows Server 2003], [Windows 2000 Server], [Windows NT Server]

------------------------------------------------------------------------------------------------
 Header          : Declared in Winbase.h; include Windows.h.
 Library         : Use Advapi32.lib.
 Unite delphi   : JwaWinBase.pas ( + JwaWinNT.pas pour PTOKEN_PRIVILEGES).
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  BOOL AdjustTokenPrivileges (              // [out] 0 si echec
    HANDLE            TokenHandle,          // [in]  Handle vers le Token
    BOOL              DisableAllPrivileges, // [in]  Si 1, desactive ts les privileges du token.
    PTOKEN_PRIVILEGES NewState,             // [in]  Specifie les attributs des privileges a
                                            //       modifier.
    DWORD             BufferLength,         // [in]  Taille de NewState en octets.
    PTOKEN_PRIVILEGES PreviousState,        // [out] Pointe vers une structure stockant l'etat
                                            //       des privileges avant la modification.
    PDWORD            ReturnLength          // [in,out] Taille  de PreviousState en octets.
  );

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  Les privileges et leurs attributs sont transmis grace a la structure PTOKEN_PRIVILEGES, qui
  est un pointeur vers la structure TOKEN_PRIVILEGES definie ci dessous.
  (la declaration en Delphi se trouve dans l'unite JwaWinNT.pas )

  typedef struct TOKEN_PRIVILEGES {
    DWORD PrivilegeCount;
    LUID_AND_ATTRIBUTES Privileges [ANYSIZE_ARRAY];
  }

  typedef struct LUID_AND_ATTRIBUTES {
    LUID Luid;
    DWORD Attributes;
  };


  La fonction AdjustTokenPrivileges accepte differentes valeurs pour Attributes :

  0                     --> Desactive le privilege correspondant.  
  SE_PRIVILEGE_ENABLED  --> Active le privilege correspondant
  SE_PRIVILEGE_REMOVED  --> Retire le privilege correspondant de la liste des privileges du
     Token. Le retrait d'un privilege est irreversible jusqu'a la fin de la session : Toute
     tentative d'acces a ce privilege (pour le reactiver par exemple) sera un echec et
     declenchera l'exception ERROR_NOT_ALL_ASSIGNED.
     L'utilisation de cet attribut n'est pas possible avec NT/2K/XP.

	

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  Remarques sur la taille du buffer NewState  :
  ---------------------------------------------

    - Le type TOKEN_PRIVILEGES permet deja de stocker 1 LUID_AND_ATTRIBUTES, donc de transmettre
      1 privilege. Donc, pour modifier 1 seul privilege, il suffit d'allouer
      SizeOf (TOKEN_PRIVILEGES) octets pour NewState.
    - Pour transmettre plusieurs privileges d'un coup, il faut compter SizeOf (TOKEN_PRIVILEGES)
      octets pour le premier privilege, et SizeOf (LUID_AND_ATTRIBUTES) octets par privileges
      supplementaires. Donc, pour modifier n privileges, il faut allouer :
      Sizeof (TOKEN_PRIVILEGES) + (N-1) * Sizeof (LUID_AND_ATTRIBUTES) octets pour NewState.

  Remarques sur le buffer PreviousState :
 ----------------------------------------

    Si vous prevoyez un buffer a cet effet, AdjustTokenPrivileges sauvegardera l'etat des
    privileges dans une structure TOKEN_PRIVILEGES avant de les modifier.

    L'utilisation de PreviousState est facultative : vous pouvez utiliser un pointeur nul pour
    PreviousState et 0 pour ReturnLength. Cependant je vous la conseille parce que :
    - En regardant quels privileges ont etes sauvegardes dans PreviousState, le programme
      peut verifier quels privileges ont etes effectivement modifies.
    - En utilisant PreviousState, il est facile de retablir l'ancien etat des privileges apres
      les avoir utilises. (Souhaitable en termes de securite)

    Pour pouvoir utiliser PreviousState, le Token doit avoir ete ouvert avec les droits
    TOKEN_QUERY (en plus des droits TOKEN_ADJUST_PRIVILEGES)

    Taille du buffer PreviousState :
    - La taille de PreviousState n'est jamais superieure a celle de NewState.
    - Si la taille memoire allouee a PreviousState est insuffisante, la fonction echoue et ne
      modifie aucun privilege. L'espace memoire necessaire a PreviousState est alors renvoye
      dans Returnlength.

------------------------------------------------------------------------------------------------

 Exemple : SetPrivilegeAttribute
 --------------------------------


 SetPrivilegeAttribute utilise AdjustTokenPrivileges pour activer ou desactiver un privilege
 dans le Token du process specifie.

 bPrivilegeState contient le nouvel etat que l'on veut assigner au privilege :
  - True pour SE_PRIVILEGE_ENABLED
  - False pour 0 (desactive le privilege)

 En cas de reussite, la fonction renvoie vrai et caError est egal a 0.
 En cas d'echec, la fonction renvoie faux, et caError contient le numero de l'exception
 correspondante.	

 Remarque : Etant donne que le retrait d'un privilege est (pour l'instant) impossible sur la
            majorite des systemes, la possibilite d'affecter l'attribut SE_PRIVILEGE_REMOVED
            n'a pas ete implementee	
*)


Function SetPrivilegeAttribute (hProcess         : Handle  ;  // Handle vers le process souhaite
                                strPrivilegeName : String  ;  // Nom chaine du privilege
                                bPrivilegeState  : Boolean ;  // Nouvel etat du privilege :
                                                              // VRAI = active, FAUX = desactive
                                VAR Error        : Cardinal)  // 0 si succes
                                                 : boolean ;  // VRAI si succes

 Var
   lpNewState  : PTokenPrivileges ; // Declare dans JwaWinNT.pas
   lpPrevState : PTokenPrivileges ;
   caStateSize : Cardinal ;
   hToken  : Handle ;
   bSucces : Boolean ;

 Begin
   bSucces := False ;
   Result  := False ;
   caStateSize := 0 ;
   hToken := 0 ;
   lpNewState  := NIL ;
   lpPrevState := NIL ;

   Error := 0 ;

   SetLastError (0) ;

   // Ouverture du Token avec les droits TOKEN_QUERY et TOKEN_ADJUST_PRIVILEGES
   bSucces := OpenProcessToken (hProcess, TOKEN_QUERY + TOKEN_ADJUST_PRIVILEGES, hToken) ;

   // - Les droits TOKEN_ADJUST_PRIVILEGES sont necessaires pour pouvoir modifier l'etat des
   //   privileges avec AdjustTokenPrivileges.
   // - Les droits TOKEN_QUERY sont necessaires lorsqu'on utilise le parametre PreviousState de
   //   AdjustTokenPrivileges. (Sans cela, on obtient ERROR_ACCESS_DENIED)
   // ==> On combine les deux avec un OU LOGIQUE.
 
   If bSucces Then
     If hToken <> 0 Then // Creation des buffers
       Begin
        caStateSize := Sizeof (TOKEN_PRIVILEGES) ;     // Sizeof (TOKEN_PRIVILEGES) = 16
        // pour n privilege(s) :
        // "caStateSize := Sizeof (TTOKEN_PRIVILEGES) + (N-1) * Sizeof (LUID_AND_ATTRIBUTES)"
        // n-1 car le Type Privilege_Set contient deja la place pour 1 Type LUID_AND_ATTRIBUTES
        lpNewState  := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, caStateSize) ;
        lpPrevState := HeapAlloc (GetProcessHeap, HEAP_ZERO_MEMORY, caStateSize) ;
       End
       Else Begin
        Error   := GetLastError ;
        bSucces := False ;
       End ;

   If bSucces Then
     If (lpNewState <> NIL) AND (lpPrevState <> NIL) Then
       Begin
        lpPrevState^.PrivilegeCount := 0 ; // Reset du compteur de privilege(s) modifie(s).
        lpNewState^.PrivilegeCount  := 1 ; // Pour transmetre 1 privilege.
        If bPrivilegeState
          Then lpNewState^.Privileges [0].Attributes := SE_PRIVILEGE_ENABLED
          Else lpNewState^.Privileges [0].Attributes := 0 ;

        // Recuperation du LUID du privilege a modifier (sur le systeme local)
        lpNewState^.Privileges [0].Luid := Privilege2LUID ('', strPrivilegeName, Error) ;
        If Error <> 0 Then bSucces := False ;
       End
       Else Begin
        Error   := GetLastError ;
        bSucces := False ;
       End ;

   If bSucces Then   // Modification de l'etat du privilege
     Begin
      bSucces := AdjustTokenPrivileges (hToken, False, lpNewState, caStateSize,
                                        lpPrevState, @caStateSize) ;
      Error := GetLastError ;
      // Si la fonction AdjustTokenPrivilege reussit, GetLastError renvoie ERROR_SUCCESS (=0)
     End ;

   If bSucces AND (Error = 0) Then
     If (lpPrevState^.PrivilegeCount = 1)    // Si l'appel a AdjustTokenPrivileges a reussi, il
       Then Result := True                   // doit y avoir 1 privilege de modifie
       Else Begin
        bSucces := False ;
        Error := ERROR_NOT_ALL_ASSIGNED ;
       End ;

   SetLastError (Error) ;

   // On referme proprement les pointeurs et handles ouverts.
   If lpNewState  <> NIL Then HeapFree (GetProcessHeap, 0, lpNewState) ;
   If lpPrevState <> NIL Then HeapFree (GetProcessHeap, 0, lpPrevState) ;
   If hToken <> 0 Then CloseHandle (hToken) ;
 End ;

{---------------------------------</AdjustTokenPrivileges>-------------------------------------}

END.












